package utils

import (
	"fmt"
	"time"

	"github.com/beego/beego/v2/core/logs"
	"github.com/dgrijalva/jwt-go"
)

var (
	KEY = []byte("5McoGDMb5y")
)

func GenToken(account string) string {
	token := jwt.New(jwt.SigningMethodHS256)
	token.Claims = &jwt.StandardClaims{
		NotBefore: int64(time.Now().Unix()) - int64(1*time.Second),
		ExpiresAt: int64(time.Now().Unix() + 60*24*60*60),
		Issuer:    "eta_mini_crm",
		Subject:   account,
	}
	ss, err := token.SignedString(KEY)
	if err != nil {
		logs.Error(err)
		return ""
	}
	return ss
}

// 校验token
func CheckToken(account, token string) bool {
	t, err := jwt.Parse(token, func(*jwt.Token) (interface{}, error) {
		return KEY, nil
	})
	if err != nil {
		fmt.Println(err.Error())
		return false
	}
	if account != t.Claims.(jwt.MapClaims)["sub"] {
		return false
	}
	return t.Valid
}
